#include <stdio.h>
#include <osbind.h>


#define PROC_LIVES 0x380l
#define PROC_DREGS 0x384l
#define PROC_AREGS 0x3a4l
#define PROC_ENUM 0x3c4l
#define PROC_USP 0x3c8l
#define PROC_STK 0x3ccl
#define VALID 0x12345678L

/* program to dump out post-mortem dump area of memory at 0x0380l. */
static char *trpnam[] = {
	"RESET INITIAL SSP",
	"RESET INITIAL PC",
	"BUS ERROR (NONEXISTANT MEMORY)",
	"Address Error (BOUNDARY)",
	"Illegal Instruction Trap",
	"Zero Devide",
	"CHK instruction",
	"TRAPV instruction",
	"Privelege Violation",
	"Trace",
	"Line 1010 Emulator (line aye)",
	"Line 1111 Emulator (line eff)"
};

static char *accnam[] = {
	"n unkown",
	" user mode data reference",
	" user mode program reference",
	"n unknown",
	"n unknown",
	" supervisor mode data reference",
	" supervisor mode program reference",
	"n interrupt acknowledge"
};

static char *rwnam[] = {
	"writing",
	"reading"
};

static char *who[] = {
	"Processor",
	"Device"
};

main()
{
	long save_ssp,*ptr;
	long temp;
	char errnum,temp_chr,*ptr_chr;
	int i,t_word,*ptr_wrd,r_w,i_n,access;

	printf("\nPost Mortem Dump program V01.20.86 by Michael Curry\n");

	/* get into supervisor mode */

	save_ssp=Super(0L);

	/* now get the valid flag */

	ptr = 0x380l;

	temp= (*ptr);

	if (temp==VALID) {
		/* we have valid crash data */

		ptr_chr = PROC_ENUM;	/* get exception # */
		errnum = *ptr_chr;

		printf("\nException number %d, ",errnum);

		if (errnum>11)
			printf("*UNKNOWN*\n\n");
		else 
			printf("%s.\n\n",trpnam[errnum]);


		if (errnum==2 || errnum==3) {	/* addressing errors */
			ptr=PROC_STK+10;
			temp= *ptr;
			printf("Program counter was 0x%lx.\n",temp);

			ptr_wrd=PROC_STK;
			t_word= *ptr_wrd;
			t_word= (t_word & 31);
			r_w = (t_word>>4) & 1;
			i_n = (t_word>>3) & 1;
			access = (t_word & 7);

			
			ptr=PROC_STK+2;
			temp= *ptr;
			printf("\n%s error %s address 0x%lx, %ld decimal\nduring a%s.\n",
			  who[i_n],rwnam[r_w],temp,temp,accnam[access]);
		}

		printf("\n");

		head('D');
		ptr=PROC_DREGS;

		for (i=0;i<8;i++) {
			temp= *ptr;
			zero_fill(temp,8);
			ptr++;
		}
		printf("\n\n");
		head('A');

		ptr=PROC_AREGS;
		for(i=0;i<8;i++) {
			temp= *ptr;
			zero_fill(temp,8);
			ptr++;
		}
		printf("\n\nSixteen longwords from supervisor stack:\n");

		ptr=PROC_STK;
		for (i=0;i<8;i++) {
			temp= *ptr;
			zero_fill(temp,8);
			ptr++;
		}

		printf("\n");

		for (i=0;i<8;i++) {
			temp= *ptr;
			zero_fill(temp,8);
			ptr++;
		}

		printf("\n\n");


	} else {
		printf("\nInvalid Post Mortem Info... aborting.\n");
	}

	Super(save_ssp);

	return;
}

head(c)
char c;
{
	int i;
	for (i=0;i<8;i++) printf("<  %c%d  > ",c,i);
	printf("\n");
	return;
}

zero_fill(temp,n)
long temp;
int n;
{
	char buf[20];
	int i;

	sprintf(buf,"%lx",temp);
	for(i=0;i<n-strlen(buf);i++) putchar('0');
	printf(buf);
	putchar(' ');
	return;
}
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC